! This source code file was last time modified by Igor UA3DJY on 20181130
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine cwfilter(swl,first,swlchanged)

  use ft8_mod1, only : cw,windowc1,windowx,pivalue,facx
  use jt65_mod9 ! used to store all callsigns seen in JT modes in the memory
  parameter (NFFT=184320,NFILT1=1400,NFILT2=1600)
  real*4 window1(-NFILT1/2:NFILT1/2)
  real*4 window2(-NFILT2/2:NFILT2/2)
  logical(1), intent(in) :: swl
  logical, intent(in) :: first,swlchanged

!pushing callsigns from ALLCALL to memory
  if(first) then
     open(23,file=trim(share_dir)//'/ALLCALL.TXT',status='unknown')
     j=0
     do i=1,MAXCALLS
        read(23,1002,end=10) line
1002    format(a80)
        if(line(1:4).eq.'ZZZZ') exit
        if(line(1:2).eq.'//') cycle
        i1=index(line,',')
        if(i1.lt.4 .or. i1.gt.7) cycle
        callsign=line(1:i1-1)
        j=j+1
        call1(j)=callsign(1:6)
     enddo
     close(23)
10   ncalls=j
     if(ncalls.lt.1) then
        write(*,2) 'ALLCALL.TXT is too short or missed?','d','d' ! 44th and 46th position for "d"
2       format(a35,8x,a1,1x,a1)
        call flush(6)
     endif

     pivalue=4*atan(1.0)
     do i=0,100
       windowc1(i)=(1.0+cos(i*pivalue/100))/2
     enddo
     facx=1.0/300.0
     do i=0,200
       windowx(i)=(1.0+cos(i*pivalue/200))/2
     enddo
     windowx=facx*windowx

  endif

! this filter is being used for signal subtraction
! Create and normalize the filter
  if(first .or. swlchanged) then
     fac=1.0/float(nfft)
     sum1=0.0
     if(.not.swl) then
        do j=-NFILT1/2,NFILT1/2
           window1(j)=cos(pivalue*j/NFILT1)**2
           sum1=sum1+window1(j)
        enddo
        cw=0.
        cw(1:NFILT1+1)=window1/sum1
        cw=cshift(cw,NFILT1/2+1)
     else
        do j=-NFILT2/2,NFILT2/2
           window2(j)=cos(pivalue*j/NFILT2)
           sum1=sum1+window2(j)
        enddo
        cw=0.
        cw(1:NFILT2+1)=window2/sum1
        cw=cshift(cw,NFILT2/2+1)
     endif
     call four2a(cw,NFFT,1,-1,1)
     cw=cw*fac
  endif

  return  
end subroutine cwfilter
  