! This source code file was last time modified by Igor UA3DJY on 20181207
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine multimode_decoder(params)

  !$ use omp_lib
  use prog_args
!  use timer_module, only: timer
  use strconvert_module
  use jt65_decode
  use jt9_decode
  use jt9s_decode
  use jt10_decode
  use ft8_decode
  use ft8_mod1, only : ndecodes,allmessages,allsnrs,allfreq,hashtable

  include 'jt9com.f90'
!  include 'timer_common.inc'

  character*12 :: mycall
  character*6 :: mygrid
  character*12 :: hiscall
  character*6 :: hisgrid

  type, extends(jt65_decoder) :: counting_jt65_decoder
     integer :: decoded
  end type counting_jt65_decoder

  type, extends(jt9_decoder) :: counting_jt9_decoder
     integer :: decoded
  end type counting_jt9_decoder

  type, extends(jt9s_decoder) :: counting_jt9s_decoder
     integer :: decoded
  end type counting_jt9s_decoder
  
  type, extends(jt10_decoder) :: counting_jt10_decoder
     integer :: decoded
  end type counting_jt10_decoder
  
  type, extends(ft8_decoder) :: counting_ft8_decoder
     integer :: decoded
  end type counting_ft8_decoder

  logical first,firstspmsghash
  logical(1) swlold
  integer nutc,ndelay
  type(params_block) :: params
  data ndelay/0/
  data first/.true./
  data firstspmsghash/.true./
  data swlold/.false./
  save

  logical newdat65,newdat9,nagainjt9,nagainjt9s,nagainjt10,swlchanged,lowrms,file_exists
  character*11 line11

!character(10) dat, tim1, tim2, zon
!real(8) :: timer1,timer2 ! milliseconds
!integer(4) :: ival(8)

  type(counting_jt65_decoder) :: my_jt65
  type(counting_jt9_decoder) :: my_jt9
  type(counting_jt9s_decoder) :: my_jt9s
  type(counting_jt10_decoder) :: my_jt10
  type(counting_ft8_decoder) :: my_ft8
  
  call str_c2f(params%mycall, mycall)
  call str_c2f(params%mygrid, mygrid)
  call str_c2f(params%hiscall, hiscall)
  call str_c2f(params%hisgrid, hisgrid)
  
  ! initialize decode counts
  my_jt65%decoded = 0
  my_jt9%decoded = 0
  my_jt9s%decoded = 0
  my_jt10%decoded = 0
  my_ft8%decoded = 0
!print *,params%newdat,params%nagain,params%nagainfil
!print *,params%nfilter,params%nswl,params%nhint
  nagainjt9=.false.;  nagainjt9s=.false.;  nagainjt10=.false.

  if(.not.params%nagain) ndelay=params%ndelay
  if(ndelay.gt.0) then ! received incomplete interval
     if(params%nmode.ne.8) then; call partint(ndelay,params%nutc); &
     else; call partintft8(ndelay,params%nutc); endif
  endif

  ntrials=params%nranera

  if (params%nagain .or. (params%nagainfil .and. (params%nmode.eq.65 .or. &
      params%nmode.eq.(65+9)))) then
     open(13,file=trim(temp_dir)//'/decoded.txt',status='unknown',position='append')
  else
     open(13,file=trim(temp_dir)//'/decoded.txt',status='unknown')
  endif

  if(.not.params%nagain) nutc=params%nutc
!call date_and_time(date = dat, time = tim1, zone = zon)
!call date_and_time(values = ival)
!timer1 = dble(ival(8)) * 0.001_8 + &
!dble(ival(7)) + dble(ival(6)) * 60.0_8 + &
!dble(ival(5)) * 3600.0_8
!print *,'Decoder start: ',tim1
!print *,params%newdat,params%nagain,params%nagainfil
  swlchanged=.false.
  if(swlold.neqv.params%nswl) then
     swlchanged=.true.
     swlold=params%nswl
  endif

  if(firstspmsghash) then
     inquire(file=trim(data_dir)//'/hashtable1.txt', EXIST=file_exists)
     if(file_exists) then
1004    format(a11)
        open(27,file=trim(data_dir)//'/hashtable1.txt',access="sequential", form="formatted", action="read")
        do i=1,1024
           read(27,1004) line11
           hashtable(i-1)=line11
        enddo
        close(27)
     else
        open(27,file=trim(data_dir)//'/hashtable1.txt',access="sequential", form="formatted", action="write")
        do i=1,1024
           write(27,1004) ""
        enddo
        close(27)
     endif
     firstspmsghash=.false.
  endif

  if(first .or. swlchanged) then; call cwfilter(params%nswl,first,swlchanged); first=.false.; endif ! + ALLCALL to memory

  if(params%nmode.eq.8) then
     call agccft8(params%nswl,params%nagcc) !apply AGCc if needed
     !initialize arrays for multithreading decoding
     ndecodes=0
     allmessages='                      '
     allsnrs=0
     allfreq=0.
     numcores=omp_get_num_procs()
     nuserthr=params%nmt
     if(nuserthr.ne.0) then
        if(nuserthr.eq.1 .or. nuserthr.eq.2 .or. nuserthr.eq.4 .or. nuserthr.eq.8 &
           .or. nuserthr.eq.12) numcores=nuserthr
     endif
     numthreads=1
     if(numcores.gt.1 .and. numcores.le.3) numthreads=2
     if(numcores.ge.4 .and. numcores.lt.8) numthreads=4
     if(numcores.ge.8 .and. numcores.lt.12) numthreads=8
     if(numcores.ge.12) numthreads=12
!print *,nuserthr,numcores,numthreads
     call omp_set_dynamic(.true.)
     call omp_set_nested(.true.)

     nfa=params%nfa
     nfb=params%nfb
     nfqso=params%nfqso
     if(params%nfilter) then  ! 150Hz bandwidth for FILTER
        if(nfqso.lt.nfa .or. nfqso.gt.nfb) then
           write(*,32) nutc,'nfqso is out of bandwidth','d'; 32 format(i6.6,2x,a25,12x,a1); go to 800
        endif
        if(.not.params%lhound) then
           nfa=max(nfa,nfqso-50)
           nfb=min(nfb,nfqso+50)
        else
           nfa=max(nfa,nfqso-290)
           nfb=min(nfb,nfqso+290)
        endif
        numthreads=min(8,numthreads)
     endif
     if(params%nagainfil) then
        if(nfqso.lt.nfa .or. nfqso.gt.nfb) then
           write(*,64) nutc,'nfqso is out of bandwidth','d'; 64 format(i6.6,2x,a25,12x,a1); go to 800
        endif
        nfa=max(nfa,nfqso-25) ! 75Hz bandwidth for decode via double click
        nfb=min(nfb,nfqso+25)
        numthreads=min(4,numthreads)
     endif

!     call timer('decft8  ',0)
if(numthreads.eq.1) then
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfa,nfb,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
endif
if(numthreads.eq.2) then
     nfmid=nfa+nint(abs(nfb-nfa)/2.)
     if((nfmid+1).gt.nfb) nfmid=nfb-1
!!!  !$omp parallel sections num_threads(2) copyin(/timer_private/) shared(ndecoded) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(2) shared(ndecoded) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfa,nfmid,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid+1,nfb,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp end parallel sections
endif

if(numthreads.eq.4) then
     nfdelta=nint(abs(nfb-nfa)/4.)
     nfmid1=nfa+nfdelta
     nfmid2=nfmid1+nfdelta
     nfmid3=nfmid2+nfdelta
     if((nfmid3+1).gt.nfb) nfmid3=nfb-1
!!!  !$omp parallel sections num_threads(4) copyin(/timer_private/) shared(ndecoded) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(4) shared(ndecoded) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfa,nfmid1,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid3+1,nfb,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp end parallel sections
endif

if(numthreads.eq.8) then
     nfdelta=nint(abs(nfb-nfa)/8.)
     nfmid1=nfa+nfdelta
     nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta; nfmid4=nfmid3+nfdelta
     nfmid5=nfmid4+nfdelta; nfmid6=nfmid5+nfdelta; nfmid7=nfmid6+nfdelta
     if((nfmid7+1).gt.nfb) nfmid7=nfb-1
!!!  !$omp parallel sections num_threads(8) copyin(/timer_private/) shared(ndecoded) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(8) shared(ndecoded) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfa,nfmid1,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid4+1,nfmid5,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid5+1,nfmid6,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,6,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid6+1,nfmid7,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,7,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid7+1,nfb,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,8,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp end parallel sections
endif

if(numthreads.eq.12) then
     nfdelta=nint(abs(nfb-nfa)/12.)
     nfmid1=nfa+nfdelta
     nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta; nfmid4=nfmid3+nfdelta
     nfmid5=nfmid4+nfdelta; nfmid6=nfmid5+nfdelta; nfmid7=nfmid6+nfdelta
     nfmid8=nfmid7+nfdelta; nfmid9=nfmid8+nfdelta; nfmid10=nfmid9+nfdelta
     nfmid11=nfmid10+nfdelta
     if((nfmid11+1).gt.nfb) nfmid11=nfb-1
!!!  !$omp parallel sections num_threads(12) copyin(/timer_private/) shared(ndecoded) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(12) shared(ndecoded) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfa,nfmid1,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid4+1,nfmid5,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid5+1,nfmid6,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,6,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid6+1,nfmid7,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,7,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid7+1,nfmid8,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,8,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid8+1,nfmid9,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,9,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid9+1,nfmid10,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,10,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid10+1,nfmid11,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,mycall,           &
          mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,11,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,  &
          params%nftx,nutc,nfmid11+1,nfb,params%nft8depth,params%nft8filtdepth, &
          logical(params%nhint),params%napwid,           &
          mycall,mygrid,hiscall,hisgrid,params%nswl,     &
          params%nfilter,params%nstophint,12,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lft8latestart,params%lhideft8dupes,params%lhidehash,params%lbypassrxffilt)
  !$omp end parallel sections
endif

!     call timer('decft8  ',1)
     go to 800
  endif

  lowrms=.false.
  call rms_augap(params%nutc,lowrms)
  if(lowrms) go to 800

!n1000=0  ! attempt to make T10 noise blanker, some degradation in decoding
!do i=2,623998
!!if(abs(dd(i)-dd(i-1)).gt.1000) then; n1000=n1000+1; print *,i; endif
!if((dd(i+1)-dd(i)).gt.1000.0) dd(i+1)=dd(i)+(dd(i)+dd(i-1))/2.0
!if((dd(i)-dd(i+1)).gt.1000.0) dd(i+1)=dd(i)-(dd(i)+dd(i-1))/2.0
!enddo

! signal input level diagnostics
!rrr=0.
!ddd=0.
!do i=1,624000
!if (abs(dd(i)).gt.rrr) rrr=abs(dd(i))
!enddo
!ddd=20*log10(rrr)
!print *,''
!print *,'max possible sample level is 32767'
!print *,'max RX sample level',int(rrr)
!print *,''
!print *,'max possible dynamic range is 90dB'
!print *,'RX signal dynamic range',nint(ddd)
!print *,''
! end of signal input level diagnostics

  newdat65=params%newdat
  newdat9=params%newdat
  if(params%nagain .and. .not.params%nagainfil) newdat9=.true.

  nshift=26000

  call process_dd(params%nagcc,params%nmode,params%ntxmode,params%nzhsym)

  if(.not.params%nagainfil .and. params%ntxmode.eq.9 .and. params%nagain) nagainjt9=.true.
  if(.not.params%nagainfil .and. params%nmode.eq.9 .and. params%nagain) nagainjt9s=.true.
  if(.not.params%nagainfil .and. params%nagain) nagainjt10=.true.
  if(params%nagainfil) nagainjt10=.false.

  if(params%nmode.eq.10) then
     call my_jt10%decode(jt10_decoded,nutc,params%nfqso,newdat9,params%npts8,   &
          params%nfa,params%nfb,params%ntol,params%nzhsym,nagainjt10,params%nagainfil,params%ntrials10, &
          params%ntrialsrxf10,params%nfilter,params%nswl,params%nagcc,params%nhint,params%nstophint, &
          params%nlasttx,mycall,hiscall,hisgrid)
     go to 800
  endif

  if(params%nmode.eq.9) then
     call my_jt9s%decode(jt9s_decoded,nutc,params%nfqso,newdat9,params%npts8,   &
          params%nfa,params%nfb,params%nzhsym,params%nfilter,params%nswl,   &
          nagainjt9s,params%nagainfil,params%ndepth,params%nhint,params%nstophint, &
          params%nlasttx,mycall,hiscall,hisgrid)
     go to 800
  endif

  call omp_set_dynamic(.true.)
!!!  !$omp parallel sections num_threads(2) copyin(/timer_private/) shared(ndecoded) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(2) shared(ndecoded) if(.true.) !iif() needed on Mac
  !$omp section
  if(params%nmode.eq.65 .or. (params%nmode.eq.(65+9) .and. params%ntxmode.eq.65)) then
     ! We're in JT65 mode, or should do JT65 first

     nf1=params%nfa
     nf2=params%nfb

!     call timer('jt65a   ',0)
     call my_jt65%decode(jt65_decoded,nutc,nf1,nf2,params%nfqso,  &
          logical(params%nagainfil),ntrials,params%naggressive,params%nhint,mycall, &
          hiscall,hisgrid,params%nprepass,params%nswl,params%nfilter,params%nstophint, &
          params%nlasttx,params%nsdecatt,params%fmaskact,params%ntxmode,params%ntopfreq65, &
          params%nharmonicsdepth,params%showharmonics)
!     call timer('jt65a   ',1)
  else if(params%nmode.eq.(65+9) .and. params%ntxmode.eq.9) then
     ! We're in JT9 mode, or should do JT9 first
!     call timer('decjt9  ',0)
     call my_jt9%decode(jt9_decoded,nutc,params%nfqso,newdat9,params%npts8,   &
          params%nfa,params%nfsplit,params%nfb,params%ntol,params%nzhsym,                   &
          nagainjt9,params%nagainfil,params%ndepth,params%nmode,params%nhint,params%nstophint, &
          params%nlasttx,mycall,hiscall,hisgrid,params%ntxmode)
!     call timer('decjt9  ',1)
  endif

  !$omp section
  if(params%nmode.eq.(65+9)) then          !Do the other mode (we're in dual mode)
     if (params%ntxmode.eq.9) then
        if(.not.nagainjt9) then
           nf1=params%nfa
           nf2=params%nfb
!           call timer('jt65a   ',0)
           call my_jt65%decode(jt65_decoded,nutc,nf1,nf2,params%nfqso, &
           logical(params%nagainfil),ntrials,params%naggressive,params%nhint,mycall,     &
           hiscall,hisgrid,params%nprepass,params%nswl,params%nfilter,params%nstophint, &
           params%nlasttx,params%nsdecatt,params%fmaskact,params%ntxmode,params%ntopfreq65, &
           params%nharmonicsdepth,params%showharmonics)
!           call timer('jt65a   ',1)
        endif
     else
        if (params%ntxmode.eq.65 .and. params%nagain) go to 2
!        call timer('decjt9  ',0)
        call my_jt9%decode(jt9_decoded,nutc,params%nfqso,newdat9,params%npts8,&
             params%nfa,params%nfsplit,params%nfb,params%ntol,params%nzhsym,                &
             nagainjt9,params%nagainfil,params%ndepth,params%nmode,params%nhint,params%nstophint, &
             params%nlasttx,mycall,hiscall,hisgrid,params%ntxmode)
!        call timer('decjt9  ',1)
2       continue
     end if
  endif

  !$omp end parallel sections
!800 call date_and_time(date = dat, time = tim2, zone = zon)
!call date_and_time(values = ival)
!timer2 = dble(ival(8)) * 0.001_8 + &
!dble(ival(7)) + dble(ival(6)) * 60.0_8 + &
!dble(ival(5)) * 3600.0_8
!print *,'Decoding finished: ',tim2
!write (*,'(1x,a15,f6.3,a8)')'Decoding time: ',timer2-timer1, ' seconds'

!800 ndecoded = my_jt4%decoded + my_jt65%decoded + my_jt9%decoded + my_ft8%decoded
800 nsynced=0; ndecoded=0
!nsynced=0; ndecoded=0

write(*,1010) nsynced,ndecoded
1010 format('<DecodeFinished>',2i4)
  call flush(6)
  close(13) 

  return

contains

  subroutine jt65_decoded (this, utc, sync, snr, dt, freq, drift, decoded, ft, servis)
    use jt65_decode
    implicit none

    class(jt65_decoder), intent(inout) :: this
    integer, intent(in) :: utc
    real, intent(in) :: sync
    integer, intent(in) :: snr
    real, intent(in) :: dt
    integer, intent(in) :: freq
    integer, intent(in) :: drift
    character(len=22), intent(in) :: decoded
    integer, intent(in) :: ft
    character(len=1), intent(in) :: servis

    real dtshift
    dtshift=(real(nshift))/12000.0
    !$omp critical(decode_results)
    write(*,1010) utc,snr,dt-dtshift,freq,decoded,servis

1010 format(i4.4,i4,f5.1,i5,1x,'#',1x,a22,a1)
    write(13,1012) utc,nint(sync),snr,dt-dtshift,float(freq),drift,decoded,ft

1012 format(i4.4,i4,i5,f6.1,f8.0,i4,3x,a22,' JT65',i4)
    call flush(6)

    !$omp end critical(decode_results)
    select type(this)
    type is (counting_jt65_decoder)
       this%decoded = this%decoded + 1
    end select
 end subroutine jt65_decoded

  subroutine jt9_decoded (this, utc, sync, snr, dt, freq, drift, decoded, servis9)
    use jt9_decode
    implicit none

    class(jt9_decoder), intent(inout) :: this
    integer, intent(in) :: utc
    real, intent(in) :: sync
    integer, intent(in) :: snr
    real, intent(in) :: dt
    real, intent(in) :: freq
    integer, intent(in) :: drift
    character(len=22), intent(in) :: decoded
    character(len=1), intent(in) :: servis9

    !$omp critical(decode_results)
    write(*,1000) utc,snr,dt,nint(freq),decoded,servis9
1000 format(i4.4,i4,f5.1,i5,1x,'@',1x,a22,a1)
    write(13,1002) utc,nint(sync),snr,dt,freq,drift,decoded
1002 format(i4.4,i4,i5,f6.1,f8.0,i4,3x,a22,' JT9')
    call flush(6)
    !$omp end critical(decode_results)
    select type(this)
    type is (counting_jt9_decoder)
       this%decoded = this%decoded + 1
    end select
  end subroutine jt9_decoded

  subroutine jt9s_decoded (this, utc, sync, snr, dt, freq, drift, decoded, servis9)
    use jt9s_decode
    implicit none

    class(jt9s_decoder), intent(inout) :: this
    integer, intent(in) :: utc
    real, intent(in) :: sync
    integer, intent(in) :: snr
    real, intent(in) :: dt
    real, intent(in) :: freq
    integer, intent(in) :: drift
    character(len=22), intent(in) :: decoded
    character(len=1), intent(in) :: servis9

    write(*,1000) utc,snr,dt,nint(freq),decoded,servis9
1000 format(i4.4,i4,f5.1,i5,1x,'@',1x,a22,a1)
    write(13,1002) utc,nint(sync),snr,dt,freq,drift,decoded
1002 format(i4.4,i4,i5,f6.1,f8.0,i4,3x,a22,' JT9')
    call flush(6)
    select type(this)
    type is (counting_jt9s_decoder)
       this%decoded = this%decoded + 1
    end select
  end subroutine jt9s_decoded

  subroutine jt10_decoded (this, utc, sync, snr, dt, freq, drift, decoded, servis9)
    use jt10_decode
    implicit none

    class(jt10_decoder), intent(inout) :: this
    integer, intent(in) :: utc
    real, intent(in) :: sync
    integer, intent(in) :: snr
    real, intent(in) :: dt
    real, intent(in) :: freq
    integer, intent(in) :: drift
    character(len=22), intent(in) :: decoded
    character(len=1), intent(in) :: servis9

    write(*,1000) utc,snr,dt,nint(freq),decoded,servis9
1000 format(i4.4,i4,f5.1,i5,1x,'+',1x,a22,a1)
    write(13,1002) utc,nint(sync),snr,dt,freq,drift,decoded
1002 format(i4.4,i4,i5,f6.1,f8.0,i4,3x,a22,' T10')
    call flush(6)
    select type(this)
    type is (counting_jt10_decoder)
       this%decoded = this%decoded + 1
    end select
  end subroutine jt10_decoded

  subroutine ft8_decoded (this,sync,snr,dt,freq,decoded,servis8)
    use ft8_decode
    implicit none

    class(ft8_decoder), intent(inout) :: this
    real, intent(in) :: sync
    integer, intent(in) :: snr
    real, intent(in) :: dt
    real, intent(in) :: freq
    character(len=22), intent(in) :: decoded
    character(len=1), intent(in) :: servis8

    write(*,1000) nutc,snr,dt,nint(freq),decoded,servis8
1000 format(i6.6,i4,f5.1,i5,1x,'~',1x,a22,a1)
    write(13,1002) nutc,nint(sync),snr,dt,freq,0,decoded
1002 format(i6.6,i4,i5,f6.1,f8.0,i4,3x,a22,' FT8')
    call flush(6)
    call flush(13)
    
    select type(this)
    type is (counting_ft8_decoder)
       this%decoded = this%decoded + 1
    end select

    return
  end subroutine ft8_decoded

end subroutine multimode_decoder
