! This source code file was last time modified by Igor UA3DJY on August 19th, 2018
! All changes are shown in the patch file coming together with the full JTDX source code.

module ft8_decode

  type :: ft8_decoder
     procedure(ft8_decode_callback), pointer :: callback
   contains
     procedure :: decode
  end type ft8_decoder

  abstract interface
     subroutine ft8_decode_callback (this,sync,snr,dt,freq,decoded,servis8)
       import ft8_decoder
       implicit none
       class(ft8_decoder), intent(inout) :: this
       real, intent(in) :: sync
       integer, intent(in) :: snr
       real, intent(in) :: dt
       real, intent(in) :: freq
       character(len=22), intent(in) :: decoded
       character(len=1), intent(in) :: servis8
     end subroutine ft8_decode_callback
  end interface

contains

  subroutine decode(this,callback,nQSOProgress,nfqso,nftx,nutc,nfa,nfb,ndepth,nft8filtdepth,lapon,  &
                    napwid,mycall12,mygrid6,hiscall12,hisgrid6,swl,filter,stophint,nthr,numthreads, &
                    nagainfil,lft8lowth,lft8subpass,lft8latestart,lhideft8dupes,lhidehash,lbypassrxffilt)
!use wavhdr
!    use timer_module, only: timer
 !$ use omp_lib
    use ft8_mod1, only : ndecodes,allmessages,allsnrs,allfreq!,dd8
    include 'ft8_params.f90'
!type(hdr) h

    class(ft8_decoder), intent(inout) :: this
    procedure(ft8_decode_callback) :: callback
!    real sbase(NH1)
!integer*2 iwave(180000)
    real candidate(3,260)
    logical, intent(in) :: lapon,nagainfil
    logical(1), intent(in) :: swl,filter,stophint,lft8lowth,lft8subpass,lft8latestart,lhideft8dupes, &
                              lhidehash,lbypassrxffilt
    logical newdat1,lsubtract,ldupe,bcontest,lFreeText,lspecial
    character*12 mycall12,hiscall12
    character*6 mygrid6,hisgrid6
    character*6 servis8
    integer apsym(KK)
    character datetime*13
    character*22 message,message2

    bcontest=.false.; lspecial=.false.
    servis8=' '
    this%callback => callback
    write(datetime,1001) nutc        !### TEMPORARY ###
1001 format("000000_",i6.6)

    call ft8apset(mycall12,mygrid6,hiscall12,hisgrid6,bcontest,apsym,iaptype)

!write(*,1018) nQSOProgress,'d'
!1018 format(i1,44x,a1)
! For now:
! ndepth=1: no subtraction, 1 pass, belief propagation only
! ndepth=2: subtraction, 3 passes, belief propagation only
! ndepth=3: subtraction, 3 passes, bp+osd
    if((.not.filter .and. ndepth.eq.1) .or. (filter .and. nft8filtdepth.eq.1)) npass=1
    if((.not.filter .and. (ndepth.eq.2 .or. ndepth.eq.3)) .or. &
       (filter .and. (nft8filtdepth.eq.2 .or. nft8filtdepth.eq.3))) npass=3
    if(.not.filter .and. ndepth.eq.4) npass=4
    syncmin=1.5
    do ipass=1,npass
      newdat1=.true.
      if(ipass.eq.1) then
        if(lft8lowth .or. swl) syncmin=1.225
        lsubtract=.true.
        if(.not.filter .and. ndepth.eq.1) lsubtract=.false.
        if(filter .and. nft8filtdepth.eq.1) lsubtract=.true. ! subtract in Filter single pass
      elseif(ipass.eq.2) then
         if(lft8lowth .or. swl) syncmin=1.5
!        n2=ndecodes
!        if(ndecodes.eq.0) cycle
        lsubtract=.true.
      elseif(ipass.eq.3) then
         if(lft8lowth .or. swl) syncmin=1.1
!        n3=ndecodes
!        if((ndecodes-n2).eq.0) cycle
        if(npass.eq.3) then; lsubtract=.false.; else; lsubtract=.true.; endif
      elseif(ipass.eq.4) then
!        if((ndecodes-n3).eq.0) cycle
        lsubtract=.false.
      endif 

      jzvar=62 ! Search over +/- 2.5s relative to 0.5s TX start time
      if(lft8latestart .or. swl) jzvar=86 ! Search over +/- 3.5s relative to 0.5s TX start time
      !call timer('sync8   ',0)
      call sync8(nfa,nfb,syncmin,nfqso,candidate,ncand,jzvar,swl,ipass)
      !call timer('sync8   ',1)
      do icand=1,ncand
        sync=candidate(3,icand)
        f1=candidate(1,icand)
        xdt=candidate(2,icand)
        i3bit=0
        !call timer('ft8b    ',0)
!if(nthr.eq.1) print *,ipass,'nthr1',newdat1
!if(nthr.eq.2) print *,ipass,'nthr2',newdat1
!write (*,"(F5.2,1x,I1,1x,I4,1x,F4.2)") candidate(2,icand)-0.5,ipass,nint(candidate(1,icand)),candidate(3,icand)
        call ft8b(newdat1,nQSOProgress,nfqso,nftx,ndepth,nft8filtdepth,lapon,napwid,       &
                  lsubtract,nagainfil,iaptype,mygrid6,bcontest,f1,xdt,apsym,nharderrors,   &
                  dmin,nbadcrc,message,message2,xsnr,swl,stophint,nthr,mycall12,hiscall12, &
                  lFreeText,ipass,filter,lft8subpass,lspecial,i3bit,lhidehash,lbypassrxffilt)
        nsnr=nint(xsnr) 
        xdt=xdt-0.5
!        hd=nharderrors+dmin
        !call timer('ft8b    ',1)
        if(nbadcrc.eq.0) then
        if(lspecial)then; nspecial=2; else; nspecial=1; endif
           do k=1,nspecial
              if(k.eq.2) message=message2
!           call jtmsg(message,iflag)
!           if(bcontest) call fix_contest_msg(mygrid6,message)
!           if(iand(iflag,31).ne.0) message(22:22)='?'
              ldupe=.false.
              if(message(1:6).eq."      ") ldupe=.true. 
              if(.not.ldupe) then
                 do id=1,ndecodes
                    if(lhideft8dupes) then
                       if(message.eq.allmessages(id) .and. (nsnr.le.allsnrs(id) .or. &
                          (nsnr.gt.allsnrs(id) .and. abs(allfreq(id)-f1).lt.45.0))) then
                          ldupe=.true.
                          exit
                       endif
                    else
                       if(message.eq.allmessages(id) .and. ((nsnr.le.allsnrs(id) .and. abs(allfreq(id)-f1).lt.45.0) &
                          .or. (nsnr.gt.allsnrs(id) .and. abs(allfreq(id)-f1).lt.45.0 .and. numthreads.ne.1))) then
                          ldupe=.true.
                          exit
                       endif
                    endif
                 enddo
              endif
              if(.not.ldupe) then
!$omp critical(update_arrays)
                 ndecodes=ndecodes+1
                 allmessages(ndecodes)=message
                 allsnrs(ndecodes)=nsnr
                 allfreq(ndecodes)=f1
                 if(iaptype.eq.0) then
                    if(.not.lFreeText .or. lspecial) servis8=' '
                    if(.not.lspecial .and. lFreeText) then
                       if(abs(nfqso-nint(f1)).le.10) then
                          servis8=','
                       else
                          servis8='.'
                       endif
                    endif
                 else
                    servis8='*'
                 endif
                 if(i3bit.eq.1) servis8='1'
!write (*,"(F5.2,1x,I1,1x,I4,1x,F4.2)") candidate(2,icand)-0.5,ipass,nint(candidate(1,icand)),candidate(3,icand)
!write (*,"(I1,1x,F4.2)") ipass,candidate(3,icand)
!print *,candidate(2,icand)-0.5,message
!print *,message
                 if(associated(this%callback)) call this%callback(sync,nsnr,xdt,f1,message,servis8)
!$omp end critical(update_arrays)
!$OMP FLUSH (ndecodes,allmessages,allsnrs,allfreq)
              endif
              if(k.eq.2) lspecial=.false.
           enddo
        endif
      enddo
    enddo
! h=default_header(12000,NMAX)
! open(10,file='subtract.wav',status='unknown',access='stream')
! iwave(1:180000)=nint(dd8(1:180000))
! write(10) h,iwave
! close(10)

    return
  end subroutine decode
end module ft8_decode
