! This source code file was last time modified by Igor UA3DJY on 20181207
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine ft8b(newdat,nQSOProgress,nfqso,nftx,ndepth,nft8filtdepth,lapon,napwid,lsubtract, &
                nagainfil,iaptype,mygrid6,bcontest,f1,xdt,apsym,nharderrors,dmin,nbadcrc,   &
                message,message2,xsnr,swl,stophint,nthr,mycall12,hiscall12,lFreeText,       &
                imainpass,filter,lft8subpass,lspecial,i3bit,lhidehash,lbypassrxffilt)
  !!$ use omp_lib
!  use timer_module, only: timer
  use crc
  use prog_args, only : data_dir
  use ft8_mod1, only : hashtable,allmessages,ndecodes
  include 'ft8_params.f90'
  parameter (NP2=3199) ! (NP2=2812)
  character*22 message,message2,msgsent
  character*12 mycall12,hiscall12
  character*11 hiscall,call1 ! FT8v2
  character*6 mygrid6,c1,c2
  character report*3,cbits*87
  logical(1), intent(in) :: swl,stophint,filter,lft8subpass,lhidehash,lbypassrxffilt
  logical(1) falsedec,lastsync,dupemsg
  logical bcontest,nagainfil,lspecial
  real a(5)
  real s1(0:7,ND),s2(0:7,NN),s3(0:7,ND),s1sort(8*ND)
  real ps(0:7),psl(0:7)
  real bmeta(3*ND),bmetb(3*ND),bmetap(3*ND)
  real llr(3*ND),llra(3*ND),llr0(3*ND),llr1(3*ND),llrap(3*ND)           !Soft symbols
  integer*1 decoded(KK),dectmp(KK),apmask(3*ND),cw(3*ND)
  integer*1 msgbits(KK)
  integer apsym(KK)
  integer mcq(28),mde(28),mrrr(16),m73(16),mrr73(16)
  integer itone(NN)
  integer indxs1(8*ND)
  integer icos7(0:6),ip(1)
  integer nappasses(0:5)  ! the number of decoding passes to use for each QSO state
  integer naptypes(0:5,4) ! (nQSOProgress, decoding pass)  maximum of 4 passes for now
  integer*1, target:: i1hiscall(12)
  complex cd0(0:3199)
  complex ctwk(32)
  complex csymb(32)
!complex cd
  logical first,newdat,lsubtract,lapon,lFreeText
  equivalence (s1,s1sort)
  data icos7/2,5,6,0,4,1,3/
  data mcq/1,1,1,1,1,0,1,0,0,0,0,0,1,0,0,0,0,0,1,1,0,0,0,1,1,0,0,1/
  data mrrr/0,1,1,1,1,1,1,0,1,1,0,0,1,1,1,1/
  data m73/0,1,1,1,1,1,1,0,1,1,0,1,0,0,0,0/
  data mde/1,1,1,1,1,1,1,1,0,1,1,0,0,1,0,0,0,0,0,1,1,1,0,1,0,0,0,1/
  data mrr73/0,0,0,0,0,0,1,0,0,0,0,1,0,1,0,1/
  data first/.true./
  save nappasses,naptypes

  if(first) then
     mcq=2*mcq-1
     mde=2*mde-1
     mrrr=2*mrrr-1
     m73=2*m73-1
     mrr73=2*mrr73-1
     nappasses(0)=2
     nappasses(1)=2
     nappasses(2)=2
     nappasses(3)=4
     nappasses(4)=4
     nappasses(5)=3

! iaptype
!------------------------
!   1        CQ     ???    ???
!   2        MyCall ???    ???
!   3        MyCall DxCall ???
!   4        MyCall DxCall RRR
!   5        MyCall DxCall 73
!   6        MyCall DxCall RR73
!   7        ???    DxCall ???

     naptypes(0,1:4)=(/1,2,0,0/)
     naptypes(1,1:4)=(/2,3,0,0/)
     naptypes(2,1:4)=(/2,3,0,0/)
     naptypes(3,1:4)=(/3,4,5,6/)
     naptypes(4,1:4)=(/3,4,5,6/)
     naptypes(5,1:4)=(/3,1,2,0/)
     first=.false.
  endif

  lastsync=.false.
  max_iterations=30
  nharderrors=-1
  fs2=12000.0/NDOWN
  dt2=1.0/fs2
  twopi=8.0*atan(1.0)
  delfbest=0.
  ibest=0

  !call timer('ft8_down',0)
  call ft8_downsample(newdat,f1,cd0)   !Mix f1 to baseband and downsample
  !call timer('ft8_down',1)

  i0=nint((xdt+0.5)*fs2)                   !Initial guess for start of signal
  smax=0.0
  do idt=i0-8,i0+8                         !Search over +/- one quarter symbol
     call sync8d(cd0,idt,ctwk,0,sync,imainpass,lastsync)
     if(sync.gt.smax) then
        smax=sync
        ibest=idt
     endif
  enddo
  xdt2=ibest*dt2                           !Improved estimate for DT

! Now peak up in frequency
  i0=nint(xdt2*fs2)
  smax=0.0
  do ifr=-5,5                              !Search over +/- 2.5 Hz
    delf=ifr*0.5
    dphi=twopi*delf*dt2
    phi=0.0
    do i=1,32
      ctwk(i)=cmplx(cos(phi),sin(phi))
      phi=mod(phi+dphi,twopi)
    enddo
   call sync8d(cd0,i0,ctwk,1,sync,imainpass,lastsync)
    if( sync .gt. smax ) then
      smax=sync
      delfbest=delf
    endif
  enddo
  a=0.0
  a(1)=-delfbest
  call twkfreq1(cd0,NP2,fs2,a,cd0)
  xdt=xdt2
  f1=f1+delfbest                           !Improved estimate of DF
!!!write (*,"(F5.2,1x,I1,1x,F6.1,1x,a3)") xdt,imainpass,f1,'out'
  lastsync=.true.
  call sync8d(cd0,i0,ctwk,2,sync,imainpass,lastsync)

  j=0
  do k=1,NN
    i1=ibest+(k-1)*32
    csymb=cmplx(0.0,0.0)
    if( i1.ge.0 .and. i1+31 .le. NP2 ) csymb=cd0(i1:i1+31)
    call four2a(csymb,32,1,-1,1)
    s2(0:7,k)=abs(csymb(1:8))/1e3
  enddo  

! sync quality check
  is1=0
  is2=0
  is3=0
  do k=1,7
    ip=maxloc(s2(:,k))
    if(icos7(k-1).eq.(ip(1)-1)) is1=is1+1
    ip=maxloc(s2(:,k+36))
    if(icos7(k-1).eq.(ip(1)-1)) is2=is2+1
    ip=maxloc(s2(:,k+72))
    if(icos7(k-1).eq.(ip(1)-1)) is3=is3+1
  enddo
! hard sync sum - max is 21
  nsync=is1+is2+is3
  if(nsync .le. 6) then ! bail out
    nbadcrc=1
    return
  endif

  j=0
  do k=1,NN
     if(k.le.7) cycle
     if(k.ge.37 .and. k.le.43) cycle
     if(k.gt.72) cycle
     j=j+1
     s1(0:7,j)=s2(0:7,k)
  enddo  

  synclev=0.0; snoiselev=1.0
  do k=1,7
     synclev=synclev+s2(icos7(k-1),k)
  enddo
  snoiselev=(sum(s1(0:7,1:7))- synclev)/7.0
  if(snoiselev.lt.0.1) snoiselev=1.0 ! safe division
  srr=synclev/snoiselev

  nweak=1
  if((lft8subpass .or. swl) .and. srr.lt.2.5 .and. (imainpass.eq.1 .or. imainpass.eq.3)) nweak=2
  do k1=1,nweak
     if(k1.eq.1 .and. srr.lt.2.5) then !  srr.lt.2.5 -19dB SNR threshold
        if(lft8subpass .or. swl) s3=s1
        if(srr.gt.2.3) then 
           s1=s1**2
        else
           do kk1=1,8
              do mm1=1,ND
                 ss1=s1(kk1-1,mm1)
                 if(ss1.lt.5.77) then
                    s1(kk1-1,mm1)=1+8.*ss1**2-0.12*ss1**4
                 else
                    s1(kk1-1,mm1)=(ss1+5.82)**2
                 endif
              enddo
           enddo
        endif
     endif
     if(k1.eq.2 .and. srr.lt.2.5) s1=(0.5*s3)**3 ! -19dB SNR threshold
     call indexx(s1sort,8*ND,indxs1)
     xmeds1=s1sort(indxs1(nint(0.5*8*ND)))
     if(xmeds1.lt.1e-8) xmdes1=1. ! safe division
     s1=s1/xmeds1

!do k2=1,8
!print *,s1(k2-1,35)
!enddo
!print *,'end35'

     do j=1,ND
        i4=3*j-2
        i2=3*j-1
        i1=3*j
! Max amplitude
        ps=s1(0:7,j)
        r1=max(ps(1),ps(3),ps(5),ps(7))-max(ps(0),ps(2),ps(4),ps(6))
        r2=max(ps(2),ps(3),ps(6),ps(7))-max(ps(0),ps(1),ps(4),ps(5))
        r4=max(ps(4),ps(5),ps(6),ps(7))-max(ps(0),ps(1),ps(2),ps(3))
        bmeta(i4)=r4
        bmeta(i2)=r2
        bmeta(i1)=r1
        bmetap(i4)=r4
        bmetap(i2)=r2
        bmetap(i1)=r1

        if(srr.lt.2.3) then  ! -23dB decodes have srr<2.26
! Metric for Cauchy noise
           r1=log(ps(1)**3+ps(3)**3+ps(5)**3+ps(7)**3+1e-32)- &
              log(ps(0)**3+ps(2)**3+ps(4)**3+ps(6)**3+1e-32)
           r2=log(ps(2)**3+ps(3)**3+ps(6)**3+ps(7)**3+1e-32)- &
              log(ps(0)**3+ps(1)**3+ps(4)**3+ps(5)**3+1e-32)
           r4=log(ps(4)**3+ps(5)**3+ps(6)**3+ps(7)**3+1e-32)- &
              log(ps(0)**3+ps(1)**3+ps(2)**3+ps(3)**3+1e-32)
        else
! Max log metric
           psl=log(ps+1e-32)
           r1=max(psl(1),psl(3),psl(5),psl(7))-max(psl(0),psl(2),psl(4),psl(6))
           r2=max(psl(2),psl(3),psl(6),psl(7))-max(psl(0),psl(1),psl(4),psl(5))
           r4=max(psl(4),psl(5),psl(6),psl(7))-max(psl(0),psl(1),psl(2),psl(3))
        endif
        bmetb(i4)=r4
        bmetb(i2)=r2
        bmetb(i1)=r1

! Metric for Cauchy noise
!     r1=log(ps(1)**3+ps(3)**3+ps(5)**3+ps(7)**3)- &
!        log(ps(0)**3+ps(2)**3+ps(4)**3+ps(6)**3)
!     r2=log(ps(2)**3+ps(3)**3+ps(6)**3+ps(7)**3)- &
!        log(ps(0)**3+ps(1)**3+ps(4)**3+ps(5)**3)
!     r4=log(ps(4)**3+ps(5)**3+ps(6)**3+ps(7)**3)- &
!        log(ps(0)**3+ps(1)**3+ps(2)**3+ps(3)**3)
! Metric for AWGN, no fading
!     bscale=2.5
!     b0=bessi0(bscale*ps(0))
!     b1=bessi0(bscale*ps(1))
!     b2=bessi0(bscale*ps(2))
!     b3=bessi0(bscale*ps(3))
!     b4=bessi0(bscale*ps(4))
!     b5=bessi0(bscale*ps(5))
!     b6=bessi0(bscale*ps(6))
!     b7=bessi0(bscale*ps(7))
!     r1=log(b1+b3+b5+b7)-log(b0+b2+b4+b6)
!     r2=log(b2+b3+b6+b7)-log(b0+b1+b4+b5)
!     r4=log(b4+b5+b6+b7)-log(b0+b1+b2+b3)

        if(nQSOProgress .eq. 0 .or. nQSOProgress .eq. 5) then
! When bits 88:115 are set as ap bits, bit 115 lives in symbol 39 along
! with no-ap bits 116 and 117. Take care of metrics for bits 116 and 117.
           if(j.eq.39) then  ! take care of bits that live in symbol 39
              if(apsym(28).lt.0) then
                 bmetap(i2)=max(ps(2),ps(3))-max(ps(0),ps(1))
                 bmetap(i1)=max(ps(1),ps(3))-max(ps(0),ps(2))
              else 
                 bmetap(i2)=max(ps(6),ps(7))-max(ps(4),ps(5))
                 bmetap(i1)=max(ps(5),ps(7))-max(ps(4),ps(6))
              endif
           endif
        endif

! When bits 116:143 are set as ap bits, bit 115 lives in symbol 39 along
! with ap bits 116 and 117. Take care of metric for bit 115.
!        if(j.eq.39) then  ! take care of bit 115
!           iii=2*(apsym(29)+1)/2 + (apsym(30)+1)/2  ! known values of bits 116 & 117
!           if(iii.eq.0) bmetap(i4)=ps(4)-ps(0)
!           if(iii.eq.1) bmetap(i4)=ps(5)-ps(1)
!           if(iii.eq.2) bmetap(i4)=ps(6)-ps(2)
!           if(iii.eq.3) bmetap(i4)=ps(7)-ps(3)
!        endif

! bit 144 lives in symbol 48 and will be 1 if it is set as an ap bit.
! take care of metrics for bits 142 and 143
        if(j.eq.48) then  ! bit 144 is always 1
          bmetap(i4)=max(ps(5),ps(7))-max(ps(1),ps(3))
          bmetap(i2)=max(ps(3),ps(7))-max(ps(1),ps(5))
        endif 

! bit 154 lives in symbol 52 and will be 0 if it is set as an ap bit
! take care of metrics for bits 155 and 156
        if(j.eq.52) then  ! bit 154 will be 0 if it is set as an ap bit.
           bmetap(i2)=max(ps(2),ps(3))-max(ps(0),ps(1))
           bmetap(i1)=max(ps(1),ps(3))-max(ps(0),ps(2))
        endif  

     enddo

     call normalizebmet(bmeta,3*ND)
     call normalizebmet(bmetb,3*ND)
     call normalizebmet(bmetap,3*ND)

     scalefac=2.83
     llr0=scalefac*bmeta
     llr1=scalefac*bmetb
     llra=scalefac*bmetap  ! llr's for use with ap
     apmag=scalefac*(maxval(abs(bmetap))*1.01)

! pass #
!------------------------------
!   1        regular decoding
!   2        erase 24
!   3        erase 48
!   4        ap pass 1
!   5        ap pass 2
!   6        ap pass 3
!   7        ap pass 4, etc.

     if(lapon) then 
        if(.not.stophint) then
           npasses=4+nappasses(nQSOProgress)
        else
           npasses=5 
        endif
     else
        npasses=4
     endif

     do ipass=1,npasses 
               
        llr=llr0
        if(ipass.eq.2) llr=llr1
        if(ipass.eq.3) llr(1:24)=0. 
        if(ipass.eq.4) llr(1:48)=0. 
        if(ipass.le.4) then
           apmask=0
           llrap=llr
           iaptype=0
        endif
        
        if(ipass .gt. 4) then
           if(.not.stophint) then
              iaptype=naptypes(nQSOProgress,ipass-4)
           else
              iaptype=1
           endif
           if(iaptype.ge.3 .and. (abs(f1-nfqso).gt.napwid .and. abs(f1-nftx).gt.napwid) ) cycle 
           if(iaptype.eq.1 .or. iaptype.eq.2 ) then ! AP,???,??? 
              apmask=0
              apmask(88:115)=1    ! first 28 bits are AP
              apmask(144)=1       ! not free text
              llrap=llr
              if(iaptype.eq.1) llrap(88:115)=apmag*mcq
              if(iaptype.eq.2) llrap(88:115)=apmag*apsym(1:28)
              llrap(116:117)=llra(116:117)  
              llrap(142:143)=llra(142:143)
              llrap(144)=-apmag
           endif
           if(iaptype.eq.3) then   ! mycall, dxcall, ???
              apmask=0
              apmask(88:115)=1   ! mycall
              apmask(116:143)=1  ! hiscall
              apmask(144)=1      ! not free text
              llrap=llr
              llrap(88:143)=apmag*apsym(1:56)
              llrap(144)=-apmag
           endif
           if(iaptype.eq.4 .or. iaptype.eq.5 .or. iaptype.eq.6) then  
              apmask=0
              apmask(88:115)=1   ! mycall
              apmask(116:143)=1  ! hiscall
              apmask(144:159)=1  ! RRR or 73 or RR73
              llrap=llr
              llrap(88:143)=apmag*apsym(1:56)
              if(iaptype.eq.4) llrap(144:159)=apmag*mrrr 
              if(iaptype.eq.5) llrap(144:159)=apmag*m73 
              if(iaptype.eq.6) llrap(144:159)=apmag*mrr73 
           endif
           if(iaptype.eq.7) then   ! ???, dxcall, ???
              apmask=0
              apmask(116:143)=1  ! hiscall
              apmask(144)=1      ! not free text
              llrap=llr
              llrap(115)=llra(115)
              llrap(116:143)=apmag*apsym(29:56)
              llrap(144)=-apmag
           endif
    
        endif

        cw=0
     !call timer('bpd174  ',0)
        call bpdecode174(llrap,apmask,max_iterations,decoded,cw,nharderrors,  &
             niterations)
     !call timer('bpd174  ',1)
        dmin=0.0
        if(((.not.filter .and. ndepth.ge.3) .or. (filter .and. nft8filtdepth.eq.3)) .and. nharderrors.lt.0) then
           ndeep=3
           if(abs(nfqso-f1).le.napwid .or. abs(nftx-f1).le.napwid) then
             if((ipass.eq.3 .or. ipass.eq.4) .and. .not.nagainfil) then
               ndeep=3 
             else   
               ndeep=4  
             endif
           endif
!           if(nagainfil .or. swl) ndeep=5 ! 30 against 26 -23dB, more than 15sec to decode and many false decodes
!           if(swl) ndeep=4 ! 29 decodes -23dB, 7..12sec to decode
           if(nagainfil) ndeep=5
        !call timer('osd174  ',0)
!print *,omp_get_nested(),OMP_get_num_threads()
           call osd174(llrap,apmask,ndeep,decoded,cw,nharderrors,dmin,nthr)
        !call timer('osd174  ',1)
        endif
        nbadcrc=1
        message='                      '
        xsnr=-99.0
        if(count(cw.eq.0).eq.174) cycle           !Reject the all-zero codeword
!###     if(any(decoded(73:75).ne.0)) cycle        !Reject if any of the 3 extra bits is nonzero

        if(nharderrors.ge.0 .and. nharderrors+dmin.lt.60.0 .and. &        
           .not.(sync.lt.2.0 .and. nharderrors.gt.35)      .and. &
           .not.(ipass.gt.2 .and. nharderrors.gt.39)       .and. &
           .not.(ipass.eq.4 .and. nharderrors.gt.30)             &
          ) then

          call chkcrc12a(decoded,nbadcrc)
        else
           nharderrors=-1
           cycle 
        endif
!###
        i3bit=4*decoded(73) + 2*decoded(74) + decoded(75)
        iFreeText=decoded(57)
!     if(nbadcrc.eq.0) write(*,3001) nharderrors,nbadcrc,i3bit
!3001 format('A',3i5)
!###
        if(nbadcrc.eq.0) then
           message2='                      '
           dectmp=decoded
           if(i3bit.eq.1) decoded(57:)=0
           call extractmessage174(decoded,message,ncrcflag)
           decoded=dectmp
           call genft8(message,mygrid6,bcontest,i3bit,msgsent,msgbits,itone)

           if(i3bit.eq.1) then
              do i=1,12
                 i1hiscall(i)=ichar(hiscall12(i:i))
              enddo
              icrc10=crc10(c_loc(i1hiscall),12)
              write(cbits,1001) decoded
1001          format(87i1)
              read(cbits,1002) ncrc10,nrpt
1002          format(56x,b10,b6)

!we shall not get out of hashtable boundaries
              if(ncrc10.gt.1023 .or. ncrc10.lt.0) then ! false decode?
                 nbadcrc=1
                 message='                      '
                 return 
              endif

              irpt=nrpt-30
              i1=index(message,' ')
              i2=index(message(i1+1:),' ') + i1
              c1=message(1:i1)
              c2=message(i1+1:i2)
!print *, hiscall12, icrc10
!print *, hashtable(ncrc10)
              lspecial=.true.
! extract base hiscall
              idxslash=index(hiscall12,'/')
              if(idxslash.ne.0) then
                 hiscall='ERROR'
                 ilength=len(trim(hiscall12))
                 if(ilength-idxslash.gt.idxslash-1) then
                    hiscall=hiscall12(idxslash+1:ilength)
                 else
                    hiscall=hiscall12(1:idxslash-1)
                 endif
                 if(ilength-idxslash.eq.idxslash-1) then
                    if(ilength-idxslash.eq.3) then ! KH1 9M6
                       if(hiscall12(3:3).ge.'0' .and. hiscall12(3:3).le.'9') &
                          hiscall=hiscall12(idxslash+1:ilength)
                       if(hiscall12(7:7).ge.'0' .and. hiscall12(7:7).le.'9') &
                          hiscall=hiscall12(1:idxslash-1)
                    endif
                    if(ilength-idxslash.eq.4) then ! 3DA0 3XY4
                       if(hiscall12(4:4).ge.'0' .and. hiscall12(4:4).le.'9') &
                          hiscall=hiscall12(idxslash+1:ilength)
                       if(hiscall12(9:9).ge.'0' .and. hiscall12(9:9).le.'9') &
                          hiscall=hiscall12(1:idxslash-1)
                    endif
                 endif
              else
                  hiscall=hiscall12(1:11)
              endif

              if(icrc10.ne.ncrc10 .and. hashtable(ncrc10).ne."           ") hiscall=hashtable(ncrc10) ! previously stored hash

              write(report(1:3),1010) irpt
1010          format(i3.2)
              if(report(1:1).ne.'-') report(1:1)='+'
              if(ncrc10.eq.icrc10 .or. hashtable(ncrc10).ne."           ") then
                 if(icrc10.eq.ncrc10 .and. (hashtable(icrc10).eq."           " &
                    .or. hashtable(icrc10).ne.hiscall12(1:11))) then
!$omp critical(update_hashtable)
                    hashtable(icrc10)=hiscall ! new hash to table
                    open(27,file=trim(data_dir)//'/hashtable1.txt',access="sequential", form="formatted", action="write")
                    do i=1,1024
                       write(27,1004) hashtable(i-1)
                    enddo
1004                format(a11)
                    close(27)
!$omp end critical(update_hashtable)
!$OMP FLUSH (hashtable)
                 endif
                 message=c1//' '//trim(hiscall)//' RR73'
                 message2=c2//' '//trim(hiscall)//' '//report
              else if(.not.lhidehash .or. (lbypassrxffilt .and. abs(nint(f1)-nfqso).le.10)) then
! 092815 -16  0.3 1831 ~ ES1JA <...> RR73  iaptype=2 false decode
! 092815 -16  0.3 1831 ~ 3L3UYQ <...> -27
                 if(iaptype.gt.0) then; nbadcrc=1; message='                      '; return; endif ! false decode
                 message=c1//' '//'<...>'//' RR73'
                 message2=c2//' '//'<...>'//' '//report
              else if(lhidehash) then !skip message with nonrecognized 2nd call from hash in stdout
                 nbadcrc=1
                 message='                      ' ! do not return: we have to subtract this signal
              endif
! Collapse multiple blanks
              if(nbadcrc.eq.0) then
                iz=len(trim(message))
                do iter=1,10
                   ib2=index(message(1:iz),'  ')
                   if(ib2.lt.1) exit
                   message=message(1:ib2)//message(ib2+2:)
                   iz=iz-1
                enddo
                do iter=1,10
                   ib2=index(message2(1:iz),'  ')
                   if(ib2.lt.1) exit
                   message2=message2(1:ib2)//message2(ib2+2:)
                   iz=iz-1
                enddo
!print *,message
!print *,message2
              endif
           endif
           if(nbadcrc.eq.0) then
             qual=1.0-(nharderrors+dmin)/60.0
             xsnr=0.001
             xsnrtmp=0.001
             do i=1,79
!message packing debug
!if (i.le.7 .or. (i.ge.37 .and. i.le.43) .or. i.gt.72) then
!print *,i,"synclev",maxval(s2(:,i),1) 
!else
!print *,i,"datalev",maxval(s2(:,i),1)
!endif
!print *,"demod",maxloc(s2(:,i))-1,"genft8",itone(i)
                xsig=s2(itone(i),i)**2
                xnoi=(sum(s2(0:7,i)**2) - xsig)/7.0
                if(xnoi.lt.0.01) xnoi=0.01 ! safe division and better accuracy
                if(xnoi.lt.xsig) then; xsnr=xsig/xnoi; else; xsnr=1.01; endif
                xsnrtmp=xsnrtmp+xsnr
             enddo
             xsnr=xsnrtmp/79.0-1.0
             xsnr=10.0*log10(xsnr)-26.5
             if(xsnr.gt.7.0) xsnr=xsnr+(xsnr-7.0)/2.0
             if(xsnr .lt. -17.0) then
               if(xsnr.lt.-22.5 .and. xsnr.gt.-23.5) xsnr=-22.5 ! safe division and better accuracy
               xsnr=xsnr-(1.0+1.4/(23.0+xsnr))**2+1.2
             endif
             if(xsnr .lt. -23.0) xsnr=-23.0
             rxdt=xdt-0.5
             if(qual.lt.0.39 .or. nint(xsnr).eq.-23 .or. rxdt.lt.-0.5 .or. rxdt.gt.1.9) then
! 075815 -23 2.0 2693 ~ SDGCGLYHHQ/ES
! 041430 -23 -1.3 1950 ~ K8.CET4PNB0I
! filter false -23 ./ freemsgs while trying to avoid blocking content messages using multiple criteria
               if(iFreeText.eq.1 .and. nint(xsnr).eq.-23 .and. (rxdt.lt.-0.5 .or. rxdt.gt.1.9)) then
                 islash=index(message,'/')
                 ispace=index(message,' ')
                 if((ispace.eq.0 .or. ispace.gt.12) .and. (index(message,'.').gt.0 .or. islash.gt.7 .or. &
                    (islash.gt.5 .and. islash.lt.5))) then
!print *,"0 -23_dot_slash freemsg"
!print *,message
                    nbadcrc=1
                    message='                      '
                    return 
                 endif
               endif
               if(iaptype.ge.1 .and. iaptype.le.3) then
                 if(i3bit.eq.2 .and. iFreeText.eq.0) then
!print *,"1 i3bit",i3bit
!print *,message
                    nbadcrc=1
                    message='                      '
                    return 
                 endif
               endif
               if(lapon .and. (iaptype.eq.1 .or. iaptype.eq.2)) then
                 falsedec=.false.
                 call chkfalse(message,mycall12,falsedec)
                 if(falsedec) then
!print *,"2 chkfalse Hint",iaptype
!print *,message
                    nbadcrc=1
                    message='                      '
                    return 
                 endif
               endif
               if(iaptype.eq.0 .and. message(1:2).ne.'CQ' &
                 .and. message(1:3).ne.'DE ' .and. message(1:3).ne.'QRZ') then
                 if(iFreeText.eq.1) then
                    falsedec=.false.
                    call filtersfree(message,falsedec)
                    if(falsedec) then
!print *,"3 filtersfree not Hint"
!print *,message
                       nbadcrc=1
                       message='                      '
                       return 
                    endif
                 endif
                 if(iFreeText.eq.0) then
                    falsedec=.false.
!not Hint decodes starting with mycall shall not be checked against ALLCALL.TXT
                    call1=message(1:index(message,' ')-1)
                    if(len_trim(call1).le.3 .or. &
                       (len_trim(call1).gt.3 .and. index(mycall12,trim(call1)).eq.0)) &
                       call chkfalse(message,mycall12,falsedec)
                    if(falsedec) then
!print *,"4 chkfalse not Hint"
!print *,message
                       nbadcrc=1
                       message='                      '
                       return 
                    endif
                 endif
               endif
               if(iaptype.eq.0 .and. (message(1:3).eq.'CQ ' &
                 .or. message(1:3).eq.'DE ' .or. message(1:4).eq.'QRZ ')) then
                 falsedec=.false.
                 call filterscq2(message,falsedec,iFreeText)
                 if(falsedec) then
!print *,"5 filterscq2 freemsg:",iFreeText
!print *,message
                    nbadcrc=1
                    message='                      '
                    return 
                 endif
               endif
             endif
             if(message(1:9).eq."CQ ......" .or. message(7:13).eq." ......") then
               nbadcrc=1
               message='                      '
               return 
             endif
! CQ 083TRB PJ46
             if(message(1:3).eq."CQ " .and. message(4:4).ge.'0' .and. message(4:4).le.'9' &
              .and. message(5:5).ge.'0' .and. message(5:5).le.'9' &
              .and. message(6:6).ge.'0' .and. message(6:6).le.'9' &
              .and. message(7:7).ge.'A' .and. message(7:7).le.'Z' &
              .and. message(10:10).eq." ") then
               nbadcrc=1
               message='                      '
               return 
             endif
! ZP/K2PAL NU1T   *  false decode
             if(iaptype.ge.2 .and. iaptype.le.6 .and. index(mycall12,'/').eq.0) then
               islpos=index(message,'/')
               imycallpos=index(message,trim(mycall12))
               if(islpos.ne.0 .and. imycallpos.ne.0 .and. islpos.lt.imycallpos) then
                 nbadcrc=1
                 message='                      '
                 return 
               endif
             endif
           endif

           dupemsg=.false.
           do ki=1,ndecodes
             if (allmessages(ki).eq.message) dupemsg=.true.
           enddo
           if(lsubtract .and. .not.dupemsg) then
              if(nthr.eq.1) call subtractft81(itone,f1,xdt2)
              if(nthr.eq.2) call subtractft82(itone,f1,xdt2)
              if(nthr.eq.3) call subtractft83(itone,f1,xdt2)
              if(nthr.eq.4) call subtractft84(itone,f1,xdt2)
              if(nthr.eq.5) call subtractft85(itone,f1,xdt2)
              if(nthr.eq.6) call subtractft86(itone,f1,xdt2)
              if(nthr.eq.7) call subtractft87(itone,f1,xdt2)
              if(nthr.eq.8) call subtractft88(itone,f1,xdt2)
              if(nthr.eq.9) call subtractft89(itone,f1,xdt2)
              if(nthr.eq.10) call subtractft810(itone,f1,xdt2)
              if(nthr.eq.11) call subtractft811(itone,f1,xdt2)
              if(nthr.eq.12) call subtractft812(itone,f1,xdt2)
           endif
!if(iaptype.eq.1) then
!qual=1.0-(nharderrors+dmin)/60.0 ! scale qual to [0.0,1.0]
!print *,qual
!else
!nbadcrc=1
!message='                      '
!endif
!!if(lapon .and. nbadcrc.eq.0 .and. iaptype.ge.2 .and. iaptype.le.3) then
!!write (*,"(I1.1,1x,I1.1,1x,F5.3,36x,A1)") iaptype,iFreeText,qual,'d'
!!flush(6)
!!endif
           if(iFreeText.eq.1) then; lFreeText=.true.; else; lFreeText=.false.; endif
           return
        endif
     enddo
  enddo
  return
end subroutine ft8b

subroutine normalizebmet(bmet,n)
  real bmet(n)

  bmetav=sum(bmet)/real(n)
  bmet2av=sum(bmet*bmet)/real(n)
  var=bmet2av-bmetav*bmetav
  if( var .gt. 0.0 ) then
     bmetsig=sqrt(var)
  else
     bmetsig=sqrt(bmet2av)
  endif
  bmet=bmet/bmetsig
  return
end subroutine normalizebmet


function bessi0(x) 
! From Numerical Recipes
   real bessi0,x
   double precision p1,p2,p3,p4,p5,p6,p7,q1,q2,q3,q4,q5,q6,q7,q8,q9,y
   save p1,p2,p3,p4,p5,p6,p7,q1,q2,q3,q4,q5,q6,q7,q8,q9
   data p1,p2,p3,p4,p5,p6,p7/1.0d0,3.5156229d0,3.0899424d0,1.2067492d0, &
      0.2659732d0,0.360768d-1,0.45813d-2/
   data q1,q2,q3,q4,q5,q6,q7,q8,q9/0.39894228d0,0.1328592d-1,           &
      0.225319d-2,-0.157565d-2,0.916281d-2,-0.2057706d-1,               &
      0.2635537d-1,-0.1647633d-1,0.392377d-2/

   if (abs(x).lt.3.75) then 
      y=(x/3.75)**2
      bessi0=p1+y*(p2+y*(p3+y*(p4+y*(p5+y*(p6+y*p7))))) 
   else
      ax=abs(x)
      y=3.75/ax 
      bessi0=(exp(ax)/sqrt(ax))*(q1+y*(q2+y*(q3+y*(q4         &
           +y*(q5+y*(q6+y*(q7+y*(q8+y*q9))))))))
   endif
   return
end function bessi0

