module strconvert_module
  implicit none

  public :: str_f2c, str_c2f

contains
  subroutine str_f2c(str_f, str_c)
    use, intrinsic :: iso_c_binding, only: c_char, c_null_char
    implicit none
    character(len=*), intent(in) :: str_f
    character(kind=c_char), bind(C), intent(out) :: str_c(*)
    integer :: i

    do i = 1, len_trim(str_f)
      str_c(i) = str_f(i:i + 1)
    end do
    str_c(i) = c_null_char
  end subroutine str_f2c

  subroutine str_c2f(str_c, str_f)
    use, intrinsic :: iso_c_binding, only: c_char, c_null_char
    implicit none
    character(kind=c_char), bind(C), intent(in) :: str_c(*)
    character(len=*), intent(out) :: str_f
    integer :: i

    str_f = ""
    i = 1
    do
      if (str_c(i) == c_null_char) then
        return
      endif
      str_f = trim(str_f) // trim(str_c(i))
      i = i + 1
    end do
  end subroutine str_c2f
end module strconvert_module