! This source code file was last time modified by Igor UA3DJY on May 30th, 2018
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine subtractft81(itone,f0,dt)

! Subtract an ft8 signal
!
! Measured signal  : dd(t)    = a(t)cos(2*pi*f0*t+theta(t))
! Reference signal : cref(t)  = exp( j*(2*pi*f0*t+phi(t)) )
! Complex amp      : cfilt(t) = LPF[ dd(t)*CONJG(cref(t)) ]
! Subtract         : dd(t)    = dd(t) - 2*REAL{cref*cfilt}

  !$ use omp_lib
  use ft8_mod1, only : dd8,cw,cfilt1,cref1
! NMAX=15*12000,NFFT=15*12000,NFRAME=1920*79
  parameter (NFFT=184320,NMAX=180000,NFRAME=151680)
  integer itone(79)

  nstart=dt*12000+1
  call genft8refsig(itone,cref1,f0)
  do i=1,nframe
    id=nstart-1+i 
    if(id.ge.1.and.id.le.NMAX) then
      cfilt1(i)=dd8(id)*conjg(cref1(i))
    else
      cfilt1(i)=0.0
    endif
  enddo
  cfilt1(nframe+1:)=0.0
  call four2a(cfilt1,nfft,1,-1,1)
  cfilt1(1:nfft)=cfilt1(1:nfft)*cw(1:nfft)
  call four2a(cfilt1,nfft,1,1,1)
!$omp critical(subtraction)
  do i=1,nframe
     j=nstart+i-1
     if(j.ge.1 .and. j.le.NMAX) dd8(j)=dd8(j)-2*REAL(cfilt1(i)*cref1(i))
  enddo
!$omp end critical(subtraction)
!$OMP FLUSH (dd8)

  return
end subroutine subtractft81
