! This source code file was last time modified by Igor UA3DJY on 20181130
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine sync8(nfa,nfb,syncmin,nfqso,candidate,ncand,jzvar,swl,ipass)

  use ft8_mod1, only : dd8,windowx,facx
  include 'ft8_params.f90'
  complex cx(0:NH1)
  real s(NH1,NHSYM)
  real x(NFFT1)
  real sync2d(NH1,-jzvar:jzvar)
  real red(NH1)
  real candidate0(3,250)
  real candidate(3,260)
  real freq
  integer jpeak(NH1)
  integer indx(NH1)
  integer ii(1)
  integer icos7(0:6)
  data icos7/2,5,6,0,4,1,3/                   !Costas 7x7 tone pattern
  logical(1), intent(in) :: swl
  equivalence (x,cx)

! Compute symbol spectra, stepping by NSTEP steps.  
  tstep=NSTEP/12000.0                         
  df=12000.0/NFFT1                            !3.125 Hz

  if(ipass.eq.1) then
     do j=1,NHSYM
        ia=(j-1)*NSTEP + 1
        ib=ia+NSPS-1
        x(1:759)=0.
        if(j.ne.1) then; x(760:960)=dd8(ia-201:ia-1)*windowx(200:0:-1); else; x(760:960)=0.; endif
        x(961:2880)=facx*dd8(ia:ib)
        if(j.ne.NHSYM) then; x(2881:3081)=dd8(ib+1:ib+201)*windowx; else; x(2881:3081)=0.; endif
        x(3082:)=0.
        call four2a(x,NFFT1,1,-1,0)              !r2c FFT
        do i=1,NH1
           s(i,j)=SQRT(real(cx(i))**2 + aimag(cx(i))**2)
        enddo
     enddo
  endif
  if(ipass.eq.2) then
     do j=1,NHSYM
        ia=(j-1)*NSTEP + 1
        ib=ia+NSPS-1
        x(1:759)=0.
        if(j.ne.1) then; x(760:960)=dd8(ia-201:ia-1)*windowx(200:0:-1); else; x(760:960)=0.; endif
        x(961:2880)=facx*dd8(ia:ib)
        if(j.ne.NHSYM) then; x(2881:3081)=dd8(ib+1:ib+201)*windowx; else; x(2881:3081)=0.; endif
        x(3082:)=0.
        call four2a(x,NFFT1,1,-1,0)              !r2c FFT
        do i=1,NH1
           s(i,j)=real(cx(i))**2 + aimag(cx(i))**2
        enddo
     enddo
  endif
  if(ipass.eq.3) then
     do j=1,NHSYM
        ia=(j-1)*NSTEP + 1
        ib=ia+NSPS-1
        x(1:759)=0.
        if(j.ne.1) then; x(760:960)=dd8(ia-201:ia-1)*windowx(200:0:-1); else; x(760:960)=0.; endif
        x(961:2880)=facx*dd8(ia:ib)
        if(j.ne.NHSYM) then; x(2881:3081)=dd8(ib+1:ib+201)*windowx; else; x(2881:3081)=0.; endif
        x(3082:)=0.
        call four2a(x,NFFT1,1,-1,0)              !r2c FFT
        do i=1,NH1
           s(i,j)=abs(real(cx(i))) + abs(aimag(cx(i)))
        enddo
     enddo
  endif

  ia=max(1,nint(nfa/df))
  ib=max(1,nint(nfb/df))
  nssy=NSPS/NSTEP   ! # steps per symbol
  nfos=NFFT1/NSPS   ! # frequency bin oversampling factor
  jstrt=0.5/tstep

  do j=-jzvar,+jzvar
     do i=ia,ib
        ta=0.
        tb=0.
        tc=0.
        t0a=0.
        t0b=0.
        t0c=0.
        do n=0,6
           k=j+jstrt+nssy*n
           if(k.ge.1.and.k.le.NHSYM) then
              ta=ta + s(i+nfos*icos7(n),k)
              t0a=t0a + sum(s(i:i+nfos*6:nfos,k))
           endif
           tb=tb + s(i+nfos*icos7(n),k+nssy*36)
           t0b=t0b + sum(s(i:i+nfos*6:nfos,k+nssy*36))
           if(k+nssy*72.le.NHSYM) then
              tc=tc + s(i+nfos*icos7(n),k+nssy*72)
              t0c=t0c + sum(s(i:i+nfos*6:nfos,k+nssy*72))
           endif
        enddo
        t=ta+tb+tc
        t0=t0a+t0b+t0c
        t0=(t0-t)/6.0
        if(t0.lt.1e-8) t0=1.0 ! safe division
        sync_abc=t/t0

        t=tb+tc
        t0=t0b+t0c
        t0=(t0-t)/6.0
        if(t0.lt.1e-8) t0=1.0 ! safe division
        sync_bc=t/t0
        sync2d(i,j)=max(sync_abc,sync_bc)
     enddo
  enddo

  red=0.
  do i=ia,ib
     ii=maxloc(sync2d(i,-jzvar:jzvar)) - 1 - jzvar
     j0=ii(1)
     jpeak(i)=j0
     red(i)=sync2d(i,j0)
!     write(52,3052) i*df,red(i),db(red(i))
!3052 format(3f12.3)
  enddo

  iz=ib-ia+1
  call indexx(red(ia:ib),iz,indx)
  ibase=indx(max(1,nint(0.40*iz))) - 1 + ia ! max is workaround to prevent indx getting out of bounds
  base=red(ibase)
  if(base.lt.1e-8) base=1.0 ! safe division
  red=red/base

  candidate0=0.
  k=0
  do i=1,iz
     n=ia + indx(iz+1-i) - 1
     freq=n*df
     if(abs(freq-nfqso).gt.3.0) then
        if (red(n).lt.syncmin) cycle
     else
        if (red(n).lt.1.1) cycle
     endif
     if(k.lt.250) then; k=k+1; else; exit; endif
     candidate0(1,k)=freq
     candidate0(2,k)=(jpeak(n)-1)*tstep
     candidate0(3,k)=red(n)
  enddo
  ncand=k

  fdif0=4.0; if(swl) fdif0=3.0
!  xdtdelta=0.0

! save sync only to the best of near-dupe freqs 
  do i=1,ncand
     if(i.ge.2) then
        do j=1,i-1
           fdiff=abs(candidate0(1,i)-candidate0(1,j))
!           xdtdelta=abs(candidate0(2,i))-abs(candidate0(2,j)) !!!
!           if(abs(fdiff).lt.fdif0 .and. xdtdelta.lt.0.1) then !!!
           if(fdiff.lt.fdif0 .and. abs(candidate0(1,i)-nfqso).gt.3.0) then
              if(candidate0(3,i).ge.candidate0(3,j)) candidate0(3,j)=0.
              if(candidate0(3,i).lt.candidate0(3,j)) candidate0(3,i)=0.
           endif
        enddo
!        write(*,3001) i,candidate0(1,i-1),candidate0(1,i),candidate0(3,i-1),  &
!             candidate0(3,i)
!3001    format(i2,4f8.1)
     endif
  enddo
  
! Sort by sync
  call indexx(candidate0(3,1:ncand),ncand,indx)
! Sort by frequency 
!  call indexx(candidate0(1,1:ncand),ncand,indx)
  k=1
!Put nfqso at top of list and apply lowest sync threshold for nfqso
  fprev=5004.
  do i=1,ncand
     j=indx(i)
     if(abs(candidate0(1,j)-nfqso).le.3.0 .and. candidate0(3,j).ge.1.1 .and. abs(candidate0(1,j)-fprev).gt.3.0) then
        candidate(1,k)=candidate0(1,j)
        candidate(2,k)=candidate0(2,j)
        candidate(3,k)=candidate0(3,j)
        fprev=candidate0(1,j)
        k=k+1
     endif
  enddo

  do i=ncand,1,-1
     j=indx(i)
     if(abs(candidate0(1,j)-nfqso).gt.3.0) then; syncmin1=syncmin; else; syncmin1=1.1; endif
     if(candidate0(3,j) .ge. syncmin1) then
       candidate(1,k)=candidate0(1,j)
       candidate(2,k)=candidate0(2,j)
       candidate(3,k)=candidate0(3,j)
       k=k+1
       if(k.gt.260) exit 
     endif
  enddo
  ncand=k-1

  return
end subroutine sync8
