! This source code file was last time modified by Igor UA3DJY on 20181204
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine sync8d(cd0,i0,ctwk,itwk,sync,imainpass,lastsync)

! Compute sync power for a complex, downsampled FT8 signal.

  parameter(NP2=3199,NDOWN=60)
  complex cd0(0:NP2)
  complex csync(0:6,32)
  complex csync2(32)
  complex ctwk(32)
  complex ctmp(0:31)
  complex z1,z2,z3
  logical first
  logical(1) lastsync
  integer icos7(0:6)
  data icos7/2,5,6,0,4,1,3/
  data first/.true./
  save first,twopi,fs2,dt2,taus,baud,csync

!  p(z1)=real(z1)**2 + aimag(z1)**2          !Statement function for power

! Set some constants and compute the csync array.  
  if( first ) then
    twopi=8.0*atan(1.0)
    fs2=12000.0/NDOWN                       !Sample rate after downsampling
    dt2=1/fs2                               !Corresponding sample interval
    taus=32*dt2                             !Symbol duration
    baud=1.0/taus                           !Keying rate
    do i=0,6
      phi=0.0
      dphi=twopi*icos7(i)*baud*dt2  
      do j=1,32
        csync(i,j)=cmplx(cos(phi),sin(phi)) !Waveform for 7x7 Costas array
        phi=mod(phi+dphi,twopi)
      enddo
    enddo
    first=.false.
  endif

  sync=0; ctmp=0.
  do i=0,6                              !Sum over 7 Costas frequencies and
     i1=i0+i*32                         !three Costas arrays
     i2=i1+36*32
     i3=i1+72*32
     csync2=csync(i,1:32)
     if(itwk.eq.1) csync2=ctwk*csync2      !Tweak the frequency
     z1=0.; z2=0.; z3=0.
     if(i1.lt.0 .and. i1.gt.-32) then
       ibot=abs(i1)-1; itop=30-ibot; ctmp(0:ibot)=0.; ctmp(ibot+1:31)=cd0(0:itop)
     endif
     if(i3+31.gt.NP2 .and. i3.le.NP2) then
       ibot=NP2-i3; ctmp(0:ibot)=cd0(i3:NP2); ctmp(ibot+1:31)=0.
     endif
     if(i1+31.le.NP2) then
       if(i1.ge.0) then; z1=sum(cd0(i1:i1+31)*conjg(csync2))
       else; z1=sum(ctmp*conjg(csync2)); endif
     endif
     if(i2.ge.0 .and. i2+31.le.NP2) z2=sum(cd0(i2:i2+31)*conjg(csync2))
     if(i3.ge.0) then
       if(i3+31.le.NP2) then; z3=sum(cd0(i3:i3+31)*conjg(csync2))
       else; z3=sum(ctmp*conjg(csync2)); endif
     endif
     if(.not.lastsync) then
        if(imainpass.eq.1)  sync = sync + SQRT(real(z1)**2 + aimag(z1)**2) + SQRT(real(z2)**2 + aimag(z2)**2) &
           + SQRT(real(z3)**2 + aimag(z3)**2)
        if(imainpass.eq.2)  sync = sync + real(z1)**2 + aimag(z1)**2 + real(z2)**2 + aimag(z2)**2 &
           + real(z3)**2 + aimag(z3)**2
        if(imainpass.ge.3)  sync = sync + abs(real(z1)) + abs(aimag(z1)) + abs(real(z2)) + abs(aimag(z2)) &
           + abs(real(z3)) + abs(aimag(z3))
     else
        sync = sync + real(z1)**2 + aimag(z1)**2 + real(z2)**2 + aimag(z2)**2 &
           + real(z3)**2 + aimag(z3)**2
     endif
!     sync = sync + p(z1) + p(z2) + p(z3)
  enddo
  return
end subroutine sync8d
